; setup our Screen Width and Height here for easier tracking
#ScreenWidth  = 640
#ScreenHeight = 480

; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(#ScreenWidth,#ScreenHeight,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0) 

; Use the PNG decoder for image loads.
UsePNGImageDecoder()

; load in the sprite
SpriteID = LoadSprite(#PB_Any,"ball.png")

; get the width and height of the sprites
Sprite_Width  = SpriteWidth(SpriteID)
Sprite_Height = SpriteHeight(SpriteID)

XDir = 1   ; 0=left, 1=right
YDir = 1   ; 0=up,   1=down
Speed = 2  ; how fast do we go (in pixels)

Repeat
   ; clear the screen
   ClearScreen(ClearColor)
   
   ; show our sprite
   DisplaySprite(SpriteID,X,Y)

   ; if we're moving left, subtract speed   
   If XDir = 0
      X = X - Speed 
   Else
      ; otherwise add speed
      X = X + Speed 
   EndIf
   
   ; if we hit the right edge, start moving left
   If X > #ScreenWidth - Sprite_Width
      XDir = 0
   EndIf
   ; if we hit the left edge, start moving right
   If X < 1
      XDir = 1
   EndIf

   ; if we're moving up, subtract speed
   If YDir = 0
      Y = Y - Speed 
   Else
      ; otherwise add speed
      Y = Y + Speed 
   EndIf
   
   ; if we hit the bottom edge, start moving up
   If Y > #ScreenHeight - Sprite_Height
      YDir = 0
   EndIf
   ; if we hit the top edge, start moving down
   If Y < 1
      YDir = 1
   EndIf

   ; put up text for exiting
   StartDrawing(ScreenOutput())
     DrawText(0,460,"Press any key To quit")
   StopDrawing()

   FlipBuffers()

   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)

End



; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 28
; FirstLine = 42