; setup our Screen Width and Height here for easier tracking
#ScreenWidth  = 640
#ScreenHeight = 480

; Initialize the sprite and keyboard, and a 640x480, 16-bit screen, add #PB_Screen_NoSynchronization so we don't use syncing
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(#ScreenWidth,#ScreenHeight,16,"App Title",#PB_Screen_NoSynchronization) = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0)

; setup our timers and init their value
FPSTimer = ElapsedMilliseconds()
Start_Time.f = ElapsedMilliseconds()

; setup our FPS tracking variables
FPS = 0
FPSCounter = 0

; setup our real time tracking variables
XUnit.f = 0.250
YUnit.f = 0.125

; setup our starting points
X.f = 0
Y.f = 0
  
; Keep going until the user hits ESCAPE
Repeat
   ; clear the screen
  ClearScreen(ClearColor)
  ; get the current time
  Current_Time.f = ElapsedMilliseconds()
  ; determine how much time has passed
  Time_Passed.f = Current_Time - Start_Time
  ; reset the start time
  Start_Time = Current_Time
  ; Add X's current value to the number of units it is to move
  ; multiplied the amount of time that has passed
  X = X + (XUnit * Time_Passed)
  ; if the resultant value goes beyond the screen, reset to 0
  If X > #ScreenWidth
    X = 0
  EndIf
  
  ; Add Y's current value to the number of units it is to move
  ; multiplied the amount of time that has passed
  Y = Y + (YUnit * Time_Passed)
  ; if the resultant value goes beyond the screen, reset to 0
  If Y > #ScreenHeight
    Y = 0
  EndIf
  
  
  If StartDrawing(ScreenOutput()) 
    ; draw out the box
    Box(X,Y,20,20,RGB(255,0,255))
    
    ; show the current FPS
    DrawText(0,460,"FPS = " + Str(FPS) + "  --  Press ESC To exit...")
  Else
    MessageRequester("Error!", "Unable to Draw to ScreenOutput()", #PB_MessageRequester_Ok)
    End
  EndIf
  
  StopDrawing()
  
  ExamineKeyboard()

  FlipBuffers()
  
  ; if the current time is 1000 milliseconds (1 second)
  ; past the starting timer
  If ElapsedMilliseconds() > FPSTimer + 1000
    ; set the FPS var to the FPS counter
    FPS = FPSCounter
    ; reset the counter
    FPSCounter = 0
    ; reset the timer
    FPSTimer = ElapsedMilliseconds()
  Else
    ; otherwise, ad 1 to the counter variable
    FPSCounter = FPSCounter + 1
  EndIf
  
Until KeyboardReleased(#PB_Key_Escape)

End
; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 4