; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0) 

; setup our structure
Structure Ships
           EngineType.w   ; 0=slow, 1=medium, 2=Fast
           WeaponsType.w  ; 0=basic, 1=advanced
           Shields.w      ; 200-400
           Armor.w        ; 200-400
EndStructure

; setup our freighter structure and inherit all of the structure
; elements from Ships 
Structure Freighters Extends Ships
           Name.s         ; name of the freigther
           Cargo.l        ; 20000 - 50000 units
EndStructure

; setup our fighter structure and inherit all of the structure
; elements from Ships 
Structure Fighters Extends Ships
           Name.s         ; name of the figther
           SpeedBooster.w ; 0=level 1 (moderate), 1 = level 2 (Fast)
           Dexterity.w    ; 0=level 1 (moderate), 1 = level 2 (Fast)
EndStructure

; setup a new list for the Freighters
NewList Freighter.Freighters()

; setup a new list for the Fighters
NewList Fighter.Fighters()

;Now let's just populate two Freighters by hand
AddElement(Freighter())
Freighter()\Name = "Big Freighter"
Freighter()\Cargo = 50000
Freighter()\EngineType = 0
Freighter()\WeaponsType = 0
Freighter()\Shields= 200
Freighter()\Armor = 300

AddElement(Freighter())
Freighter()\Name = "Medium Freighter"
Freighter()\Cargo = 35000
Freighter()\EngineType = 1
Freighter()\WeaponsType = 0
Freighter()\Shields= 250
Freighter()\Armor = 200

;And now let's populate two Fighters by hand
AddElement(Fighter())
Fighter()\Name = "Fast Fighter"
Fighter()\SpeedBooster = 1
Fighter()\Dexterity = 1
Fighter()\EngineType = 2
Fighter()\WeaponsType = 1
Fighter()\Shields= 300
Fighter()\Armor = 200

AddElement(Fighter())
Fighter()\Name = "Mid Fighter"
Fighter()\SpeedBooster = 0
Fighter()\Dexterity = 1
Fighter()\EngineType = 2
Fighter()\WeaponsType = 1
Fighter()\Shields= 400
Fighter()\Armor = 400

ClearScreen(ClearColor)          ; clear the screen to black
   
; Set up the vertical control variable
TextY = 0
   
StartDrawing(ScreenOutput())
   
     DrawText(0,TextY,"FREIGHTERS")
     TextY = TextY + 32

     ; Step through the Freighter list and print info
     ForEach Freighter() 

         MissileText.s = "Name: " + Freighter()\Name 
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16

         MissileText.s = "Cargo: " + Str(Freighter()\Cargo)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Engine Type: " + Str(Freighter()\EngineType)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Weapons Type: " + Str(Freighter()\WeaponsType)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Shields: " + Str(Freighter()\Shields)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Armor: " + Str(Freighter()\Armor)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 32            
     Next
        
     ; display a message so the user knows how to fire/exit     
     DrawText(0,400,"Press any key to see the Fighters")

StopDrawing()

FlipBuffers()  ; show the output to the user

; wait for any key to be pressed
Repeat 
   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)


ClearScreen(ClearColor)          ; clear the screen to black
   
; Set up the vertical control variable
TextY = 0
   
StartDrawing(ScreenOutput())
   
     DrawText(0,TextY,"FIGHTERS")
     TextY = TextY + 32

     ; Step through the Fighter list and print info
     ForEach Fighter() 

         MissileText.s = "Name: " + Fighter()\Name 
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16

         MissileText.s = "Speed Booster: " + Str(Fighter()\SpeedBooster)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            
         
         MissileText.s = "Dexterity: " + Str(Fighter()\Dexterity)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Engine Type: " + Str(Fighter()\EngineType)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Weapons Type: " + Str(Fighter()\WeaponsType)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Shields: " + Str(Fighter()\Shields)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 16            

         MissileText.s = "Armor: " + Str(Fighter()\Armor)
         DrawText(0,TextY,MissileText)
         TextY = TextY + 32            
     Next
        
     ; display a message so the user knows how to fire/exit     
     DrawText(0,400,"Press any key to Exit")

StopDrawing()

FlipBuffers()  ; show the output to the user

; wait for any key to be pressed
Repeat 
   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)


End  ; end the program


; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 80
; FirstLine = 78