;****************************************************
; Various graphics/sprite procedures
;****************************************************

;****************************************************
;  Procedure: Rotate_2D_To_Array(...)
;     Author: John Logsdon
;   Last Upd: 9/28/2004
;    Purpose: Rotates a 2D image and places their
;             respective handles into an array
;       Args: The image to use, the # of rotations
;    Returns: n/a - but does fill the array
;   Comments: I grab from -5,-5 to +5, +5 of the 3D 
;             image because when an image is rotated, 
;             it changes size accordingly.I know there 
;             are mathematical ways to properly adjust 
;             for this, but I'm just using a 
;             quick-n-dirty method here.  
 ;****************************************************
Procedure Rotate_2D_To_Array(ImageToUse,Rotations)
   ; find the actual rotation amount
   ; i.e.: 360/36 = 10.  So 10-degrees is the rotation distance
   RotationAmount = 360 / Rotations
   ; start our initial angle at 0
   Angle = 0
   
   ; where to display the object for grabbing
   DisplayX = 50
   DisplayY = 50
   
   ; get the width and height plus some buffering so we don't have
   ; to call it every iteration of the loop
   Width=SpriteWidth(ImageToUse) + 10
   Height=SpriteHeight(ImageToUse) + 10
      
   ; run through the rotations
   For i = 0 To Rotations - 1
       ; Set a number in our Ships array
       Ships(i) = i
       
       ClearScreen(0,0,0)
       
       ; start up the 3D drawing piece
       Start3D()
          ; rotate the sprite, but then leave back to it's original position
          ; for next call
          RotateSprite3D(ImageToUse,Angle,0)
          ; draw the sprite using 3D
          DisplaySprite3D(ImageToUse,DisplayX,DisplayY)
       Stop3D()
       ; grab the sprite to 2D
       GrabSprite(Ships(i),DisplayX - 5,DisplayY - 5,Width,Height,0)
       ; Update the angle
       Angle = Angle + RotationAmount 
   Next
EndProcedure
; ExecutableFormat=Windows
; CursorPosition=17
; FirstLine=1
; EOF